package eu.dnetlib.pid.resolver.model;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import org.apache.commons.lang3.StringEscapeUtils;

public class ObjectProvenance {

    protected final static Gson g = new GsonBuilder().setPrettyPrinting().create();

    protected String datasource;

    protected String datasourceId;

    public String getDatasource() {
        return datasource;
    }

    public ObjectProvenance setDatasource(String datasource) {
        this.datasource = datasource;
        return this;
    }

    public String getDatasourceId() {
        return datasourceId;
    }

    public ObjectProvenance setDatasourceId(String datasourceId) {
        this.datasourceId = datasourceId;
        return this;
    }

    public String getEscapedDatasource() {
        return StringEscapeUtils.escapeXml11(this.datasource);
    }

    public String getEscapedDatasourceId() {
        return StringEscapeUtils.escapeXml11(this.datasourceId);
    }


    @Override
    public String toString() {
        return g.toJson(this);
    }

}